//	FitLine.js
//	http://www.pictrix.jp/	Umezawa
//


if (documents.length > 0 && activeDocument.pathItems.length > 0){


	SelObj = activeDocument.selection;

tgePos = new Array( Array( 2 ), Array( 2 ) );
orgPos = new Array( Array( 2 ), Array( 2 ) );

ap = new Array();
op = new Array();
numpnt = 0;
closesw = 0;

	count = 0;
_001:
	for ( j = 0; j < SelObj.length; j++ ){

		for ( i = 0; i < SelObj[ j ].pathPoints.length; i++ ){

			if ( SelObj[ j ].pathPoints[ i ].selected == PathPointSelection.ANCHORPOINT ){

				tgePos[ count ] = SelObj[ j ].pathPoints[ i ].anchor;
				op[ count ] = j;
				ap[ count++ ] = i;
				if ( count >= 2 ) {
					numpnt = SelObj[ j ].pathPoints.length - 1;
					parentpath = SelObj[ j ].pathPoints.parent;
					closesw = parentpath.closed;
					j++;
					break _001;
				}
			}
		}
	}

	count = 0;
_002:
	while ( j < SelObj.length ){

		for ( i = 0; i < SelObj[ j ].pathPoints.length; i++ ){

			if ( SelObj[ j ].pathPoints[ i ].selected == PathPointSelection.ANCHORPOINT ){

				orgPos[ count++ ]= SelObj[ j ].pathPoints[ i ].anchor;
				if ( count >= 2 ) break _002;
			}
		}
		j++;
	}

	if ( count < 2 ) alert( "Select error" );

	else {

		if ( closesw == true ){

			if ( ap[ 0 ] == 0 && ap[ 1 ] == numpnt ){

				st = 1;
				ed = numpnt - 1;
			}
			else{

				st = ( ap[ 0 ] == 0 )? numpnt : ap[ 0 ] - 1;
				ed = ( ap[ 1 ] == numpnt )? 0 : ap[ 1 ] + 1;
			}
		}

		else{

			st = ( ap[ 0 ] == 0 )? -1 : ap[ 0 ] - 1;
			ed = ( ap[ 1 ] == numpnt )? -1 : ap[ 1 ] + 1;
		}

		engine( st, 0 );
		engine( ed, 1 );
	}
}


function engine( sted, n )
{
	var err;
	var dt = new Array();
	var wk = new Array();
	var pos = new Array();

	if ( sted == -1 )
		near( pos, orgPos[ 0 ], orgPos[ 1 ], tgePos[ n ] );
	else	{
		err = inter( pos, orgPos[ 0 ], orgPos[ 1 ], tgePos[ n ], SelObj[ op[ n ] ].pathPoints[ sted ].anchor );
		if ( err )
			near( pos, orgPos[ 0 ], orgPos[ 1 ], tgePos[ n ] );
	}

	pathPnt = SelObj[ op[ n ] ].pathPoints[ ap[ n ] ];

	pathPnt.anchor = pos;

	VSUB3( dt, pos, tgePos[ n ] );

	wk = pathPnt.leftDirection;
	VADD( wk, dt );
	pathPnt.leftDirection = wk;

	wk = pathPnt.rightDirection;
	VADD( wk, dt );
	pathPnt.rightDirection = wk;
}


function inter( ret, p3,p4, p1, p2 )
{
	var v1 = new Array;
	var v2 = new Array;
	var d1, d2, wk;

	VNORM3( v1, p2, p1 );
	VNORM3( v2, p4, p3 );

	wk = v2[ 0 ];
	v2[ 0 ] = v2[ 1 ];
	v2[ 1 ] = wk;
	if ( v2[ 0 ] ) v2[ 0 ] = -v2[ 0 ];
	else		     v2[ 1 ] = -v2[ 1 ];

	d1 = v2[ 0 ] * ( p1[ 0 ] - p3 [ 0 ] ) + v2[ 1 ] * ( p1[ 1 ] - p3[ 1 ] );
	d2 = v1[ 0 ] * v2[ 0 ] + v1[ 1 ] * v2[ 1 ];

	if ( d2 > -0.009 && d2 < 0.009 ){
		return -1;
	}
	else{

		ret[ 0 ] = p1[ 0 ] - v1[ 0 ] * ( d1 / d2 );
		ret[ 1 ] = p1[ 1 ] - v1[ 1 ] * ( d1 / d2 );
		return 0;
	}
}


/*
function inter( ret, p1, p2, p3, p4 )
{
	var m1, m2, mx;

	if ( p2[ 0 ] - p1[ 0 ] ){

	}

	m1 = ( p2[ 1 ] - p1[ 1 ] ) / ( p2[ 0 ] - p1[ 0 ] );
	m2 = ( p4[ 1 ] - p3[ 1 ] ) / ( p4[ 0 ] - p3[ 0 ] );
	mx = m1 - m2;

	if ( Math.abs( mx ) > 1e-6 ){
		ret[ 0 ] = ( m1 * p1[ 0 ] - m2 * p3[ 0 ] + p3[ 1 ] - p1[ 1 ] ) / mx;
		ret[ 1 ] = ( ret[ 0 ] - p1[ 0 ] ) * m1 + p1[ 1 ];
		return 0;
	}
	else
		return -1;
}
*/


function near( ret, p1, p2, p3 )
{
	var v1 = new Array;
	var v2 = new Array;

	VNORM3( v1, p2, p1 );
	VSUB3( v2, p3, p1 );
	VADDM3( ret, p1, v1, VDOT( v1, v2 ) );
}



function VDOT( v1, v2 )
{
	return ( v1[ 0 ] * v2[ 0 ] + v1[ 1 ] * v2[ 1 ] );
}

function VADDM3( v3, v1, v2, s )
{
	v3[ 0 ] = v1[ 0 ] + v2[ 0 ] * s;
	v3[ 1 ] = v1[ 1 ] + v2[ 1 ] * s;
}

function VNORM3( v3, v1, v2 )
{
	VSUB3( v3, v1, v2 );
	VDIV( v3, VLEN( v3 ) );
}

function VDIV( v1, s )
{
	v1[ 0 ] /= s;
	v1[ 1 ] /= s;
}

function VSUB3( v3, v1, v2 )
{
	v3[ 0 ] = v1[ 0 ] - v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] - v2[ 1 ];
}

function VADD( v1, v2 )
{
	v1[ 0 ] += v2[ 0 ];
	v1[ 1 ] += v2[ 1 ];
}

function VLEN( v )
{
	return ( Math.sqrt( v[ 0 ] * v[ 0 ] + v[ 1 ] * v[ 1 ] ) );
}














